# Návod na instalaci a spuštění aplikace
* Nutná podmínka první instalace je připojení k internetu.

## Instalace podpůrného softwaru Docker a Docker Copmose
1. V prohližeči otevřete https://runnable.com/docker/getting-started/
2. Na hlavní stránce pro instalaci vyberte Váš operační systém.
3. Postupujte podle instrukcí pro daný operační systém.

## Spuštění aplikace
1. Otevřete hlavní adresář aplikace kde se nachází soubor `docker-compose.yaml` a složky `backend` a `frontend`

2. Spusťte kostru aplikace pomocí příkazu
```
// spuštění na popředí v konzoli
docker-compose up
// nebo spuštění na pozadí
docker compose up -d)
```
* První spuštění může trvat trochu déle. Kontejnery se musí stáhnout a vytvořit.
* Docker spustí 3 docker kontejnery: postgres, hasura a frontend
* Postgres má otevřenou komunikaci na portu 5432, Hasura 8080 a frontend klasicky http port 80. Pro úspěšné spuštění musí být tyto porty k dispozici.

3. Nahrejte testovácí data do PostgreSQL databáze příkazem pg_dump
```
// tento příkaz vypíše na výstup aktivní kontejnery
docker ps
...
CONTAINER ID        NAMES                 IMAGE                                  STATUS
26aab15b8924        aplikace_frontend_1   aplikace_frontend                      Up 30 seconds
57a0389971de        aplikace_hasura_1     hasura/graphql-engine:v1.0.0-alpha44   Up 28 seconds
b7fbf36e841b        aplikace_postgres_1   postgres                               Up 32 seconds
```
* vyberte název nebo id kontejneru, který má v názvu postgres, v tomto případě `aplikace_postgres_1`.
* Zkopírujte dump testovací databáze dovnitř kontejneru příkazem
```
// docker cp <adresar s dump souborem> <kontejner>:/<ulozeni v kontejneru>
docker cp backend/database_dump.sql aplikace_postgres_1:/database_dump.sql
```
* nahrejte data do do databáze
```
docker exec aplikace_postgres_1 psql -U postgres -f database_dump.sql
// Tento příkaz vytvoří databázové schéma a nahraje testovací data.
```

1. Konfigurace Hasura serveru.
* Otevřete ve webovém prohlížeči Hasura konzoli na adrese http://localhost:8080/console/metadata/actions
* Pomocí tlačítka `Import metadata` importujte soubor `hasura-metadata.json`

5. Aplikace je připravena k použití v testovacím režimu http://localhost