--
-- PostgreSQL database dump
--

-- Dumped from database version 10.6
-- Dumped by pg_dump version 11.2

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET client_min_messages = warning;
SET row_security = off;

--
-- Name: public; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA public;


--
-- Name: SCHEMA public; Type: COMMENT; Schema: -; Owner: -
--

COMMENT ON SCHEMA public IS 'standard public schema';


--
-- Name: update_log_after_agent_shift_queue_action(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION public.update_log_after_agent_shift_queue_action() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
BEGIN
    IF (TG_OP = 'DELETE') THEN
      INSERT INTO log SELECT TG_OP, OLD.queue_id, OLD.agent_id, OLD.author, OLD.shift_id, NOW(), OLD.start_time_utc, OLD.end_time_utc;
      RETURN OLD;
    ELSIF (TG_OP = 'UPDATE' OR TG_OP = 'INSERT') THEN
      IF (NEW.source != 'agatha') THEN
        RETURN NEW;
      END IF;
      INSERT INTO log SELECT TG_OP, NEW.queue_id, NEW.agent_id, NEW.author, NEW.shift_id, NOW(), NEW.start_time_utc, NEW.end_time_utc;
      RETURN NEW;
    END IF;
    RETURN NULL;
  END;
$$;


SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: agent_assigned_queues; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.agent_assigned_queues (
    agent_id bigint,
    queue_id bigint
);


--
-- Name: agent_boocsek; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.agent_boocsek (
    id bigint NOT NULL,
    first_name text NOT NULL,
    last_name text NOT NULL,
    email text NOT NULL,
    staff text,
    active boolean,
    team_manager bigint,
    site text,
    "position" text,
    channel text,
    tier text,
    team text,
    purecloud_id text,
    position_abbr text
);


--
-- Name: agent_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.agent_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: agent_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.agent_id_seq OWNED BY public.agent_boocsek.id;


--
-- Name: agent_off_shift; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.agent_off_shift (
    id bigint NOT NULL,
    shift_id bigint,
    start_time_utc timestamp without time zone,
    end_time_utc timestamp without time zone,
    agent_id bigint,
    off_reason text
);


--
-- Name: agent_off_shift_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.agent_off_shift_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: agent_off_shift_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.agent_off_shift_id_seq OWNED BY public.agent_off_shift.id;


--
-- Name: agent_on_shift; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.agent_on_shift (
    id bigint NOT NULL,
    shift_id bigint,
    start_time_utc timestamp without time zone,
    end_time_utc timestamp without time zone,
    agent_id bigint
);


--
-- Name: agent_on_shift_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.agent_on_shift_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: agent_on_shift_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.agent_on_shift_id_seq OWNED BY public.agent_on_shift.id;


--
-- Name: agent_shift_queue; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.agent_shift_queue (
    shift_id bigint,
    updated_on_utc timestamp without time zone DEFAULT now(),
    agent_id bigint,
    queue_id bigint,
    start_time_utc timestamp without time zone,
    end_time_utc timestamp without time zone,
    source text DEFAULT 'agatha'::character varying,
    author text
);


--
-- Name: log; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.log (
    action text,
    queue_id bigint,
    agent_id bigint,
    author text,
    shift_id bigint,
    created_on_utc timestamp without time zone,
    start_time_utc timestamp without time zone,
    end_time_utc timestamp without time zone
);


--
-- Name: queue; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.queue (
    id bigint NOT NULL,
    name text NOT NULL,
    purecloud_id text,
    balkan_id bigint,
    group_name text
);


--
-- Name: queue_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.queue_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: queue_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.queue_id_seq OWNED BY public.queue.id;


--
-- Name: shift; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.shift (
    id bigint NOT NULL,
    name text NOT NULL,
    description text,
    length integer,
    minspacing integer,
    delete_on_utc timestamp without time zone,
    created_on_utc timestamp without time zone,
    created_by text,
    modified_on_utc timestamp without time zone,
    modified_by text,
    maxspacing integer
);


--
-- Name: shift_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.shift_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: shift_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.shift_id_seq OWNED BY public.shift.id;


--
-- Name: verint_shift_agents; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE public.verint_shift_agents (
    id bigint NOT NULL,
    shift_id bigint NOT NULL,
    shift_name text NOT NULL,
    agent_ids bigint[],
    agent_emails text[],
    on_shift integer DEFAULT 1,
    off_reasons text[],
    start_time_utc timestamp without time zone,
    end_time_utc timestamp without time zone
);


--
-- Name: verint_shift_agents_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE public.verint_shift_agents_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: verint_shift_agents_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE public.verint_shift_agents_id_seq OWNED BY public.verint_shift_agents.id;


--
-- Name: agent_boocsek id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.agent_boocsek ALTER COLUMN id SET DEFAULT nextval('public.agent_id_seq'::regclass);


--
-- Name: agent_off_shift id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.agent_off_shift ALTER COLUMN id SET DEFAULT nextval('public.agent_off_shift_id_seq'::regclass);


--
-- Name: agent_on_shift id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.agent_on_shift ALTER COLUMN id SET DEFAULT nextval('public.agent_on_shift_id_seq'::regclass);


--
-- Name: queue id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.queue ALTER COLUMN id SET DEFAULT nextval('public.queue_id_seq'::regclass);


--
-- Name: shift id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.shift ALTER COLUMN id SET DEFAULT nextval('public.shift_id_seq'::regclass);


--
-- Name: verint_shift_agents id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.verint_shift_agents ALTER COLUMN id SET DEFAULT nextval('public.verint_shift_agents_id_seq'::regclass);


--
-- Name: agent_assigned_queues agent_assigned_queues_pk; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.agent_assigned_queues
    ADD CONSTRAINT agent_assigned_queues_pk UNIQUE (agent_id, queue_id);


--
-- Name: agent_off_shift agent_off_shift_pk; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.agent_off_shift
    ADD CONSTRAINT agent_off_shift_pk PRIMARY KEY (id);


--
-- Name: agent_on_shift agent_on_shift_pk; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.agent_on_shift
    ADD CONSTRAINT agent_on_shift_pk PRIMARY KEY (id);


--
-- Name: agent_boocsek agent_pk; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.agent_boocsek
    ADD CONSTRAINT agent_pk PRIMARY KEY (id);


--
-- Name: agent_shift_queue agent_shift_queue_pk; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.agent_shift_queue
    ADD CONSTRAINT agent_shift_queue_pk UNIQUE (agent_id, queue_id);


--
-- Name: queue queue_pk; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.queue
    ADD CONSTRAINT queue_pk PRIMARY KEY (id);


--
-- Name: shift shift_pk; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.shift
    ADD CONSTRAINT shift_pk PRIMARY KEY (id);


--
-- Name: verint_shift_agents verint_shift_agents_pk; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.verint_shift_agents
    ADD CONSTRAINT verint_shift_agents_pk PRIMARY KEY (id);


--
-- Name: verint_shift_agents verint_shift_agents_pk_2; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.verint_shift_agents
    ADD CONSTRAINT verint_shift_agents_pk_2 UNIQUE (shift_id, on_shift, start_time_utc, end_time_utc, agent_ids);


--
-- Name: agent_email_uindex; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX agent_email_uindex ON public.agent_boocsek USING btree (email);


--
-- Name: agent_off_shift_id_uindex; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX agent_off_shift_id_uindex ON public.agent_off_shift USING btree (id);


--
-- Name: agent_on_shift_id_uindex; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX agent_on_shift_id_uindex ON public.agent_on_shift USING btree (id);


--
-- Name: agent_purecloud_id_uindex; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX agent_purecloud_id_uindex ON public.agent_boocsek USING btree (purecloud_id);


--
-- Name: queue_balkan_id_uindex; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX queue_balkan_id_uindex ON public.queue USING btree (balkan_id);


--
-- Name: queue_purecloud_id_uindex; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX queue_purecloud_id_uindex ON public.queue USING btree (purecloud_id);


--
-- Name: shift_id_uindex; Type: INDEX; Schema: public; Owner: -
--

CREATE UNIQUE INDEX shift_id_uindex ON public.shift USING btree (id);


--
-- Name: agent_shift_queue agent_shift_queue_action_trigger; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER agent_shift_queue_action_trigger AFTER INSERT OR DELETE OR UPDATE ON public.agent_shift_queue FOR EACH ROW EXECUTE PROCEDURE public.update_log_after_agent_shift_queue_action();


--
-- Name: agent_on_shift agent___fk; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.agent_on_shift
    ADD CONSTRAINT agent___fk FOREIGN KEY (agent_id) REFERENCES public.agent_boocsek(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: agent_off_shift agent___fk; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.agent_off_shift
    ADD CONSTRAINT agent___fk FOREIGN KEY (agent_id) REFERENCES public.agent_boocsek(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: agent_assigned_queues agent_assigned_queues_agent_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.agent_assigned_queues
    ADD CONSTRAINT agent_assigned_queues_agent_id_fkey FOREIGN KEY (agent_id) REFERENCES public.agent_boocsek(id);


--
-- Name: agent_assigned_queues agent_assigned_queues_queue_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.agent_assigned_queues
    ADD CONSTRAINT agent_assigned_queues_queue_id_fkey FOREIGN KEY (queue_id) REFERENCES public.queue(id);


--
-- Name: agent_shift_queue agent_shift_queue_agent_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.agent_shift_queue
    ADD CONSTRAINT agent_shift_queue_agent_id_fkey FOREIGN KEY (agent_id) REFERENCES public.agent_boocsek(id);


--
-- Name: agent_shift_queue agent_shift_queue_queue_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.agent_shift_queue
    ADD CONSTRAINT agent_shift_queue_queue_id_fkey FOREIGN KEY (queue_id) REFERENCES public.queue(id);


--
-- Name: log log_agent_id___fk; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.log
    ADD CONSTRAINT log_agent_id___fk FOREIGN KEY (agent_id) REFERENCES public.agent_boocsek(id) ON UPDATE SET NULL ON DELETE SET NULL;


--
-- Name: log log_queue_id___fk; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.log
    ADD CONSTRAINT log_queue_id___fk FOREIGN KEY (queue_id) REFERENCES public.queue(id) ON UPDATE SET NULL ON DELETE SET NULL;


--
-- Name: agent_on_shift shift___fk; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.agent_on_shift
    ADD CONSTRAINT shift___fk FOREIGN KEY (shift_id) REFERENCES public.shift(id) ON UPDATE CASCADE ON DELETE SET NULL;


--
-- Name: agent_off_shift shift___fk; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.agent_off_shift
    ADD CONSTRAINT shift___fk FOREIGN KEY (shift_id) REFERENCES public.shift(id) ON UPDATE CASCADE ON DELETE SET NULL;


--
-- Name: agent_boocsek team_manager___fk; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY public.agent_boocsek
    ADD CONSTRAINT team_manager___fk FOREIGN KEY (team_manager) REFERENCES public.agent_boocsek(id) ON UPDATE CASCADE ON DELETE SET NULL;


--
-- PostgreSQL database dump complete
--

