import React from 'react';
import AgentsTable from './agentsTable';
import {withStyles} from '@material-ui/core';
import PropTypes from 'prop-types';
import AgentsControls from './agentsControls';
import Paper from '@material-ui/core/Paper';


const styles = theme => ({
    root: {
        marginBottom: theme.spacing.unit * 2,
    },
    controlsWrapper: {
        paddingTop: theme.spacing.unit * 2,
    },
    tableWrapper: {
        marginTop: theme.spacing.unit * 8,
    },
});

class AgentsDashboard extends React.Component {

    render() {
        const {theme, classes} = this.props;
        const selectStyles = {
            input: base => ({
                ...base,
                color: theme.palette.text.primary,
                '& input': {
                    font: 'inherit',
                },
            }),
        };
        return (
            <React.Fragment>
                <Paper className={classes.controlsWrapper}>
                    <AgentsControls selectStyles={selectStyles} />
                </Paper>
                <Paper className={classes.tableWrapper}>
                    <AgentsTable/>
                </Paper>
            </React.Fragment>
        );
    }
}

AgentsDashboard.propTypes = {
    classes: PropTypes.object.isRequired,
    theme: PropTypes.object.isRequired,
};

export default withStyles(styles, {withTheme: true})(AgentsDashboard);
