import React from 'react';
import ErrorIcon from '@material-ui/icons/Error';
import PropTypes from 'prop-types';
import {withStyles} from '@material-ui/core/styles';


const styles = (theme) => ({
    errorIcon: {
        position: 'relative',
        bottom: -10,
        fontSize: 32,
        color: theme.palette.secondary.main,

    },
    small: {
        fontSize: theme.spacing.unit * 2,
    },
    medium: {
        fontSize: theme.spacing.unit * 4,
    },
    errorMsg: {
        color: theme.palette.secondary.main,
        paddingLeft: theme.spacing.unit,
    },
    errorWrapper: {
        padding: theme.spacing.unit,
        paddingBottom: theme.spacing.unit * 2,
    },
});

class Error extends React.Component {
    render() {
        const {msg} = this.props || null;
        const {classes} = this.props;
        return (
            <div className={classes.errorWrapper}>
                <ErrorIcon className={classes.errorIcon}></ErrorIcon>
                {msg && <span className={classes.errorMsg}>{msg}</span>}
            </div>
        );
    }
}

Error.propTypes = {
    classes: PropTypes.object.isRequired,
    msg: PropTypes.string,
};

export default withStyles(styles)(Error);
